=== debian/changelog ===
dynarmic (6.4.5+ds-1) unstable; urgency=medium

  * New upstream version 6.4.5+ds
  * d/control: add boost and llvm to -dev dependencies

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 06 Feb 2023 00:14:51 +0100
