=== debian/watch ===
# Stable releases
version=4
opts="searchmode=plain, \
  filenamemangle=s/.+\/@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none, \
  repacksuffix=+ds, \
  dversionmangle=auto" \
https://api.github.com/repos/merryhime/dynarmic/tags \
https://api.github.com/repos/merryhime/dynarmic/tarball/refs/tags/@ANY_VERSION@

# Latest master
#version=4
#opts="mode=git, \
#  pgpmode=none, \
#  pretty=describe, \
#  repacksuffix=+ds, \
#  dversionmangle=auto, \
#  uversionmangle=s/r@ANY_VERSION@/$1/" \
#https://github.com/merryhime/dynarmic.git \
#HEAD debian uupdate
