=== externals/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 if (BUILD_SHARED_LIBS)
     set(BUILD_SHARED_LIBS OFF)
     set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+    set_property(DIRECTORY PROPERTY EXCLUDE_FROM_ALL ON)
 endif()
 
 # Allow options shadowing with normal variables when subproject use old cmake policy
@@ -27,35 +28,33 @@
 if (NOT TARGET fmt::fmt)
     # fmtlib formatting library
     set(FMT_INSTALL ON)
-    add_subdirectory(fmt EXCLUDE_FROM_ALL)
+    add_subdirectory(fmt)
 endif()
 
 # mcl
 
 if (NOT TARGET merry::mcl)
     set(MCL_INSTALL ON)
-    add_subdirectory(mcl EXCLUDE_FROM_ALL)
+    add_subdirectory(mcl)
 endif()
 
 # oaknut
 
 if (NOT TARGET merry::oaknut)
-    if ("arm64" IN_LIST ARCHITECTURE)
-        add_subdirectory(oaknut EXCLUDE_FROM_ALL)
-    endif()
+    add_subdirectory(oaknut)
 endif()
 
 # robin-map
 
 if (NOT TARGET tsl::robin_map)
-    add_subdirectory(robin-map EXCLUDE_FROM_ALL)
+    add_subdirectory(robin-map)
 endif()
 
 # xbyak
 
 if (NOT TARGET xbyak::xbyak)
     if ("x86_64" IN_LIST ARCHITECTURE)
-        add_subdirectory(xbyak EXCLUDE_FROM_ALL)
+        add_subdirectory(xbyak)
     endif()
 endif()
 
@@ -68,7 +67,7 @@
         set(ZYDIS_BUILD_DOXYGEN OFF)
         set(ZYAN_ZYCORE_PATH "${CMAKE_CURRENT_LIST_DIR}/zycore" CACHE PATH "")
         set(CMAKE_DISABLE_FIND_PACKAGE_Doxygen ON)
-        add_subdirectory(zydis EXCLUDE_FROM_ALL)
+        add_subdirectory(zydis)
         add_library(Zydis::Zydis ALIAS Zydis)
     endif()
 endif()
