=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -21,8 +21,11 @@
 endif()
 
 if ("A64" IN_LIST DYNARMIC_FRONTENDS)
+    target_link_libraries(dynarmic_tests PRIVATE merry::oaknut)
+
     target_sources(dynarmic_tests PRIVATE
         A64/a64.cpp
+        A64/fibonacci.cpp
         A64/fp_min_max.cpp
         A64/misaligned_page_table.cpp
         A64/test_invalidation.cpp
