=== debian/changelog ===
dynarmic (6.5.0+ds-1) unstable; urgency=medium

  * New upstream version 6.5.0+ds
    - Closes: #1041270
  * d/control: libdynarmic6 -> libdynarmic6.5

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 21 Jul 2023 11:44:38 +0200

dynarmic (6.4.8+ds-2) unstable; urgency=medium

  * Upload to unstable

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 05 Jul 2023 22:03:58 +0200

dynarmic (6.4.8+ds-1) experimental; urgency=medium

  * New upstream version 6.4.8+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 30 May 2023 16:53:10 +0200

dynarmic (6.4.7+ds-1) experimental; urgency=medium

  * New upstream version 6.4.7+ds
  * d/patches: update catch2 patch

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 22 May 2023 01:11:01 +0200
