=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
  In the pursuit of speed, some behavior not commonly depended upon is elided.
  Therefore this emulator does not match spec.
 
-Package: libdynarmic6
+Package: libdynarmic6.5
 Architecture: any-amd64 any-arm64
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
@@ -39,7 +39,7 @@
 Section: libdevel
 Architecture: any-amd64 any-arm64
 Depends: libboost-dev,
-         libdynarmic6 (= ${binary:Version}),
+         libdynarmic6.5 (= ${binary:Version}),
          llvm-dev,
          ${misc:Depends}
 Description: ${source:Synopsis} - development
